diff --git a/php_pthreads.c b/php_pthreads.c
index 7b0c1427..f05247dc 100644
--- a/php_pthreads.c
+++ b/php_pthreads.c
@@ -30,6 +30,10 @@
 #	include <src/object.h>
 #endif
 
+#ifndef HAVE_PTHREADS_PREPARE_H
+#	include <src/prepare.h>
+#endif
+
 #ifndef ZTS
 #	error "pthreads requires that Thread Safety is enabled, add --enable-maintainer-zts to your PHP build configuration"
 #endif
@@ -260,6 +264,20 @@ static inline int php_pthreads_verify_return_type(ZEND_OPCODE_HANDLER_ARGS) {
 	return ZEND_USER_OPCODE_DISPATCH;
 } /* }}} */
 
+/* {{{ */
+static inline int php_pthreads_prepare_anon_class(zend_execute_data *execute_data) {
+	zend_string *type = 
+		Z_STR_P(EX_CONSTANT(EX(opline)->op1));
+	zend_class_entry *ce = 
+		zend_hash_find_ptr(EG(class_table), type);
+
+	if (!ce) {
+		pthreads_prepared_anon(PTHREADS_ZG(parent), type);
+	}
+
+	return ZEND_USER_OPCODE_DISPATCH;
+} /* }}} */
+
 PHP_MINIT_FUNCTION(pthreads)
 {
 	zend_class_entry ce;
@@ -820,6 +838,8 @@ PHP_MINIT_FUNCTION(pthreads)
 
 	zend_set_user_opcode_handler(ZEND_RECV, php_pthreads_recv);
 	zend_set_user_opcode_handler(ZEND_VERIFY_RETURN_TYPE, php_pthreads_verify_return_type);
+	zend_set_user_opcode_handler(ZEND_DECLARE_ANON_CLASS, php_pthreads_prepare_anon_class);
+	zend_set_user_opcode_handler(ZEND_DECLARE_ANON_INHERITED_CLASS, php_pthreads_prepare_anon_class);
 
 	return SUCCESS;
 }
diff --git a/src/object.c b/src/object.c
index c84f3cde..5f978118 100644
--- a/src/object.c
+++ b/src/object.c
@@ -443,7 +443,11 @@ zend_bool pthreads_join(pthreads_object_t* thread) {
 static inline zend_bool pthreads_routine_run_function(pthreads_object_t* object, pthreads_object_t* connection, zval *work) {
 	zend_function *run;
 	pthreads_call_t call = PTHREADS_CALL_EMPTY;
-	zval zresult;	
+	zval zresult;
+
+	if (PTHREADS_IS_THREAD(object)) {
+		PTHREADS_ZG(parent) = object;
+	}
 
 	if (pthreads_connect(object, connection) != SUCCESS) {
 		return 0;
diff --git a/src/prepare.c b/src/prepare.c
index 0c1c2593..036f978a 100644
--- a/src/prepare.c
+++ b/src/prepare.c
@@ -48,11 +48,12 @@ static  zend_trait_method_reference * pthreads_preparation_copy_trait_method_ref
 static void pthreads_prepared_resource_dtor(zval *zv); /* }}} */
 
 /* {{{ */
-static zend_class_entry* pthreads_copy_entry(pthreads_object_t* thread, zend_class_entry *candidate) {
+static zend_class_entry* pthreads_copy_entry(pthreads_object_t* thread, zend_class_entry *candidate, zend_bool allow_unbound_anon) {
 	zend_class_entry *prepared;
 
 	if (candidate->ce_flags & ZEND_ACC_ANON_CLASS) {
-		if (!(candidate->ce_flags & ZEND_ACC_ANON_BOUND)) {
+		if (!allow_unbound_anon && 
+			!(candidate->ce_flags & ZEND_ACC_ANON_BOUND)) {
 			return NULL;
 		}
 	}
@@ -381,6 +382,45 @@ static inline int pthreads_prepared_entry_function_prepare(zval *bucket, int arg
 	return ZEND_HASH_APPLY_KEEP;
 } /* }}} */
 
+/* {{{ */
+zend_class_entry* pthreads_prepared_anon(pthreads_object_t* thread, zend_string *name) {
+	HashTable *table = PTHREADS_EG(thread->creator.ls, class_table);
+	zend_class_entry *candidate = zend_hash_find_ptr(table, name);
+	zend_class_entry *prepared;
+	zend_string *lookup;
+
+	if (!candidate) {
+		return NULL;
+	}
+
+	if (candidate->type == ZEND_INTERNAL_CLASS) {
+		return zend_lookup_class(candidate->name);
+	}
+
+	lookup = zend_string_tolower(candidate->name);
+
+	if ((prepared = zend_hash_find_ptr(EG(class_table), lookup))) {
+	    zend_string_release(lookup);
+		return prepared;
+	}
+	
+	if (!(prepared = pthreads_copy_entry(thread, candidate, 1))) {
+		zend_string_release(lookup);
+		return NULL;
+	}
+
+	zend_hash_apply_with_arguments(
+		&prepared->function_table, 
+		pthreads_prepared_entry_function_prepare, 
+		3, thread, prepared, candidate);	
+	
+	zend_hash_update_ptr(EG(class_table), lookup, prepared);
+
+	zend_string_release(lookup);
+
+	return prepared;
+} /* }}} */
+
 /* {{{ */
 zend_class_entry* pthreads_prepared_entry(pthreads_object_t* thread, zend_class_entry *candidate) {
 	zend_class_entry *prepared = NULL;
@@ -401,7 +441,7 @@ zend_class_entry* pthreads_prepared_entry(pthreads_object_t* thread, zend_class_
 		return prepared;
 	}
 	
-	if (!(prepared = pthreads_copy_entry(thread, candidate))) {
+	if (!(prepared = pthreads_copy_entry(thread, candidate, 0))) {
 		zend_string_release(lookup);
 		return NULL;
 	}
@@ -418,6 +458,8 @@ zend_class_entry* pthreads_prepared_entry(pthreads_object_t* thread, zend_class_
 	return prepared;
 } /* }}} */
 
+
+
 /* {{{ */
 static inline zend_bool pthreads_constant_exists(zend_string *name) {
     int retval = 1;
diff --git a/src/prepare.h b/src/prepare.h
index 7cb52866..c336d839 100644
--- a/src/prepare.h
+++ b/src/prepare.h
@@ -25,6 +25,9 @@
 /* {{{ fetch prepared class entry */
 zend_class_entry* pthreads_prepared_entry(pthreads_object_t* thread, zend_class_entry *candidate); /* }}} */
 
+/* {{{ */
+zend_class_entry* pthreads_prepared_anon(pthreads_object_t* thread, zend_string *name); /* }}} */
+
 /* {{{ */
 void pthreads_prepare_parent(pthreads_object_t *thread); /* }}} */
 
diff --git a/src/pthreads.h b/src/pthreads.h
index 6e194494..29f4c22a 100644
--- a/src/pthreads.h
+++ b/src/pthreads.h
@@ -124,6 +124,7 @@ ZEND_BEGIN_MODULE_GLOBALS(pthreads)
 	zval  this;
 	HashTable resolve;
 	HashTable *resources;
+	void *parent;
 ZEND_END_MODULE_GLOBALS(pthreads)
 #	define PTHREADS_ZG(v) TSRMG(pthreads_globals_id, zend_pthreads_globals *, v)
 #   define PTHREADS_PID() PTHREADS_ZG(pid) ? PTHREADS_ZG(pid) : (PTHREADS_ZG(pid)=getpid())
diff --git a/tests/inherited-anon-class.phpt b/tests/inherited-anon-class.phpt
new file mode 100644
index 00000000..ce3d4700
--- /dev/null
+++ b/tests/inherited-anon-class.phpt
@@ -0,0 +1,21 @@
+--TEST--
+Test fix for #658 with inheritance
+--DESCRIPTION--
+Unbound anon class causing segfaults, we delay copy but still cannot serialize the anon
+--FILE--
+<?php
+$task = new class extends Thread {
+
+    public function run()
+    {
+        $this->prop = new class extends Threaded {};
+
+		var_dump($this->prop);
+    }
+};
+
+$task->start() && $task->join();
+--EXPECT--
+object(class@anonymous)#2 (0) {
+}
+
diff --git a/tests/no-inheritance-anon-class.phpt b/tests/no-inheritance-anon-class.phpt
new file mode 100644
index 00000000..bd57deea
--- /dev/null
+++ b/tests/no-inheritance-anon-class.phpt
@@ -0,0 +1,19 @@
+--TEST--
+Test fix for #659
+--DESCRIPTION--
+Unbound anon class causing segfaults, we delay copy but still cannot serialize the anon
+--FILE--
+<?php
+$task = new class extends Thread {
+
+    public function run()
+    {
+        $this->prop = new class {};
+
+		var_dump($this->prop); /* we do expect null: anon classes cannot be serialized */
+    }
+};
+
+$task->start() && $task->join();
+--EXPECT--
+NULL
